---
layout: post

title: PouchDB 3.5.0&#58; Vote for PouchDB
author: Dale Harvey

---

Do you support better documentation for PouchDB users? Do you value faster CORS and better Service Worker support? If so, then today you should cast your vote in support of PouchDB. Together, we can make a better future (release of PouchDB).

### New features

* [Extras API](/api.html#apis-for-plugin-authors) for PouchDB plugin authors ([#3338](https://github.com/pouchdb/pouchdb/issues/3338))
* In-memory/LocalStorage/Level.js adapters are now [browserifiable](/api.html#browser-adapter-plugins) ([#2286](https://github.com/pouchdb/pouchdb/issues/2286))

### Bugfixes

* Fallback to the [fetch API](https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API) where XMLHTTPRequest does not exist (e.g. in Service Workers) ([#3678](https://github.com/pouchdb/pouchdb/pull/3678))
* Stop triggering unneccesary OPTIONS requests during CORS replication ([#3573](https://github.com/pouchdb/pouchdb/issues/3573))
* Multitudes of documentation fixes
* Fix es3ify behavior with dependencies ([#3688](https://github.com/pouchdb/pouchdb/issues/3688))
* Add source maps to dev environment ([#3731](https://github.com/pouchdb/pouchdb/pull/3731))
* Fix constructor when called with `{name: 'foo'}` ([#3471](https://github.com/pouchdb/pouchdb/issues/3741))
* Support for Blackberry 10 ([#3737](https://github.com/pouchdb/pouchdb/pull/3737))
* Fix detection for `xhr.upload` in React Native ([#3796](https://github.com/pouchdb/pouchdb/pull/3796))
* Webpack support ([#3319](https://github.com/pouchdb/pouchdb/issues/3319))

### Get in touch

Please [file issues](https://github.com/pouchdb/pouchdb/issues) or [tell us what you think](https://github.com/pouchdb/pouchdb/blob/master/CONTRIBUTING.md#get-in-touch). And as always, a big thanks to all of our [new and existing contributors](https://github.com/pouchdb/pouchdb/graphs/contributors)!
